package cz.cuni.amis.pogamut.ut2004.examples.yaposh_duelbot;

import cz.cuni.amis.pogamut.sposh.context.UT2004Context;
import cz.cuni.amis.pogamut.ut2004.agent.module.utils.TabooSet;
import cz.cuni.amis.pogamut.ut2004.agent.navigation.NavigationState;
import cz.cuni.amis.pogamut.ut2004.agent.navigation.UT2004PathAutoFixer;
import cz.cuni.amis.pogamut.ut2004.agent.navigation.stuckdetector.UT2004DistanceStuckDetector;
import cz.cuni.amis.pogamut.ut2004.agent.navigation.stuckdetector.UT2004PositionStuckDetector;
import cz.cuni.amis.pogamut.ut2004.agent.navigation.stuckdetector.UT2004TimeStuckDetector;
import cz.cuni.amis.pogamut.ut2004.bot.impl.UT2004Bot;
import cz.cuni.amis.pogamut.ut2004.communication.messages.ItemType;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Item;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Player;
import cz.cuni.amis.utils.flag.FlagListener;

/**
 * This serves as a template bot for creating simple 1v1 DeathMatch bot using YaPOSH.
 * 
 * Many primitives are implemented so it is easy to start design the behvior using graphical
 * YaPOSH editor only.
 * 
 * If you are in NetBeans, check Projects/duelbot project/Other sources/duel-bot.lap plan.
 *
 * @author Jimmy
 */
public class DuelBotContext extends UT2004Context<UT2004Bot> {
    
    /** Current item our bot is currently going for */
    public Item targetItem = null;
    /** Target enemy player we are currently shooting at */
    public Player targetPlayer = null;
    
    /** Used to taboo items we were stuck going for or we have picked up recently */
    public TabooSet<Item> tabooItems;

    /**
     * AutoFixer monitors movement of agent and when it detects faulty
     * connection in the waypoints, it removes them from navigation logic.
     */
    UT2004PathAutoFixer autoFixer;
    
    public String state = "";

    public DuelBotContext(UT2004Bot bot) {
        super("DuelBotContext", bot);
        // IMPORTANT: Various modules of context must be initialized.
        initialize();
        
        
        
        // INITIALIZE CUSTOM MODULES
        tabooItems = new TabooSet<Item>(bot);
        
        this.getNavigation().addStrongNavigationListener(new FlagListener<NavigationState>() {
            @Override
            public void flagChanged(NavigationState changedValue) {
                switch (changedValue) {
                    case PATH_COMPUTATION_FAILED:
                    case STUCK:
                        if (targetItem != null)
                            tabooItems.add(targetItem, 10);
                    break;
                    case TARGET_REACHED:
                        if (targetItem != null)
                            tabooItems.add(targetItem, 5);                        
                    break;
                }
            }
        });
        
//        this.getWeaponPrefs()
//                .addGeneralPref(ItemType.LIGHTNING_GUN, true)
//                .addGeneralPref(ItemType.SHOCK_RIFLE, true)
//                .addGeneralPref(ItemType.FLAK_CANNON, true)
//                .addGeneralPref(ItemType.MINIGUN, true)                
//                .addGeneralPref(ItemType.LINK_GUN, true)
//                .addGeneralPref(ItemType.ASSAULT_RIFLE, true); 
        
        
    }

    public boolean isShooting;
    
    public ItemType currentWeapon;
    
    void logicBeforePlan() {
       isShooting = info.isShooting();
       currentWeapon = weaponry.getCurrentWeapon().getType();
    }

    void logicAfterPlan() {       
    }
}
