/*
 * Copyright (C) 2013 AMIS research group, Faculty of Mathematics and Physics, Charles University in Prague, Czech Republic
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package duelbot;

import cz.cuni.amis.pogamut.ut2004.communication.messages.ItemType;
import cz.cuni.amis.pogamut.ut2004.communication.messages.UT2004ItemType;

/**
 *
 * @author Jimmy
 */
public enum Weapon {
    
    SHIELD_GUN(UT2004ItemType.SHIELD_GUN),
    RIFLE(UT2004ItemType.ASSAULT_RIFLE),
    BIO(UT2004ItemType.BIO_RIFLE),
    SHOCK(UT2004ItemType.SHOCK_RIFLE),
    FLAK(UT2004ItemType.FLAK_CANNON),
    MINIGUN(UT2004ItemType.MINIGUN),
    ROCKET(UT2004ItemType.ROCKET_LAUNCHER),
    LIGHTNING(UT2004ItemType.LIGHTNING_GUN);

    public static Weapon getWeaponByItemType(ItemType type) {
        for (Weapon weapon : Weapon.values()) {
            if (weapon.itemType == type) return weapon;
        }
        return null;
    }
    
    public final ItemType itemType;
    
    private Weapon(ItemType itemType) {
        this.itemType = itemType;
    }
    
}
