package duelbot.action;

import cz.cuni.amis.pogamut.sposh.context.UT2004Context;
import cz.cuni.amis.pogamut.sposh.executor.*;
import cz.cuni.amis.pogamut.ut2004.communication.messages.ItemType;
import cz.cuni.amis.pogamut.ut2004.examples.yaposh_duelbot.DuelBotContext;
import duelbot.Combo;
import duelbot.Weapon;

/**
 * Sense ChangeWeapon for Yaposh.
 *
 * @author Jimmy
 * @param <CONTEXT> Context class of the sense. It's an shared object used by
 * all primitives. it is used as a shared memory and for interaction with the
 * environment.
 */
@PrimitiveInfo(name = "ChangeWeapon", description = "Description of ChangeWeapon")
public class ChangeWeapon<CONTEXT extends DuelBotContext> extends ParamsAction<CONTEXT> {

    /**
     * Constructor of the sense, used during automatic instantiation. The class
     * passed to the ancestor is used to determine which query method should be
     * used by the sense.
     */
    public ChangeWeapon(CONTEXT ctx) {
        super(ctx);
    }

     public void init() {
    }

    public ActionResult run(@Param("$weapon") Weapon weapon) {
        ctx.currentWeapon = weapon.itemType;
        
        ctx.getWeaponry().changeWeapon(weapon.itemType);
        
        return ActionResult.FINISHED;        
    }

    public void done() {
    }
    
}
