package duelbot.action;

import cz.cuni.amis.pogamut.sposh.executor.ActionResult;
import cz.cuni.amis.pogamut.sposh.executor.Param;
import cz.cuni.amis.pogamut.sposh.executor.ParamsAction;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.ut2004.communication.messages.ItemType;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.FlagInfo;
import cz.cuni.amis.pogamut.ut2004.examples.yaposh_duelbot.DuelBotContext;
import duelbot.Weapon;

/**
 * Shoot sensed player (player detected by sense triggering this action). 
 * Shooting will be stopped when this action is done().
 *
 * @author knight
 */
@PrimitiveInfo(name="ShootPlayer", description="Starts shooting a player, if is visible.")
public class ShootPlayer extends ParamsAction<DuelBotContext> {

    public ShootPlayer(DuelBotContext ctx) {
        super(ctx);
    }

    public void init() {        
    }

    public ActionResult run() {
        if (ctx.getPlayers().canSeePlayers()) {
            ctx.getShoot().shoot(ctx.getPlayers().getNearestVisiblePlayer());
            ctx.isShooting = true;
        } else {
            ctx.getLog().warning("CANNOT START SHOOTING AS THERE IS NO VISIBLE PLAYER!");
            ctx.getShoot().stopShooting();
            ctx.isShooting = false;
        }
        return ActionResult.FINISHED;        
    }

    public void done() {           
    }
}
