package duelbot.sense;

import cz.cuni.amis.pogamut.sposh.executor.Param;
import cz.cuni.amis.pogamut.sposh.executor.ParamsSense;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.ut2004.communication.messages.ItemType;
import cz.cuni.amis.pogamut.ut2004.examples.yaposh_duelbot.DuelBotContext;
import duelbot.Weapon;

/**
 * How much ammunition does bot have in its current weapon.
 *
 * @author Honza
 */
@PrimitiveInfo(name="Ammo", description="How much ammunition does current weapon have?")
public class Ammo extends ParamsSense<DuelBotContext, Integer> {

    public Ammo(DuelBotContext ctx) {
        super(ctx, Integer.class);
    }

    public Integer query(@Param("$weapon") Weapon weapon) {
        return ctx.getWeaponry().getAmmo(weapon.itemType);
    }
}
