package duelbot.sense;

import cz.cuni.amis.pogamut.sposh.context.UT2004Context;
import cz.cuni.amis.pogamut.sposh.executor.Param;
import cz.cuni.amis.pogamut.sposh.executor.ParamsSense;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;

/**
 * Sense AmmoCurrent for Yaposh.
 *
 * @author Jimmy
 * @param <CONTEXT> Context class of the sense. It's an shared object used by
 * all primitives. it is used as a shared memory and for interaction with the
 * environment.
 */
@PrimitiveInfo(name = "AmmoCurrent", description = "Description of AmmoCurrent")
public class AmmoCurrent<CONTEXT extends UT2004Context> extends ParamsSense<CONTEXT, Integer> {

    public AmmoCurrent(CONTEXT ctx) {
        super(ctx, Integer.class);
    }

    public Integer query() {
        return ctx.getWeaponry().getCurrentAmmo();
    }
}
