package duelbot.sense;

import cz.cuni.amis.pogamut.sposh.executor.Param;
import cz.cuni.amis.pogamut.sposh.executor.ParamsSense;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.ut2004.examples.yaposh_duelbot.DuelBotContext;
import duelbot.Item;

/**
 * Is our bot currently moving somewhere?
 *
 * @author knight
 */
@PrimitiveInfo(name="IsReachableItem", description="Whether some item is reachable?")
public class IsReachableItem extends ParamsSense<DuelBotContext, Boolean> {

    public IsReachableItem(DuelBotContext ctx) {
        super(ctx, Boolean.class);
    }

    public Boolean query(@Param("$type") Item item) {
        return
            ctx.getFwMap().getNearestItem(
                ctx.tabooItems.filter(ctx.getItems().getSpawnedItems(item.category).values()),
                ctx.getInfo().getNearestNavPoint()
            ) != null;    
    }
}
